## pkcs11-provider 1.0

=== Makefile ===
.PHONY: all check check-style check-style-show check-style-fix clean generate-code generate-docs

all:
	if [ ! -d "builddir" ]; then \
		meson setup builddir; \
	fi; \
	meson compile -C builddir pkcs11

check:
	meson test -C builddir

clean:
	rm -rf builddir

check-style:
	@lines=`git diff -U0 --no-color --relative origin/main -- ':!src/pkcs11.h' | clang-format-diff -p1 |wc -l`; \
	if [ "$$lines" != "0" ]; then \
		echo "Coding Style issues detected"; \
		exit 1; \
	else \
		echo "Coding Styles checks out"; \
	fi

check-style-show:
	git diff -U0 --no-color --relative origin/main -- ':!src/pkcs11.h' | clang-format-diff -p1

check-style-fix:
	git diff -U0 --no-color --relative origin/main -- ':!src/pkcs11.h' | clang-format-diff -i -p1

generate-code:
	for pfile in src/*.pre; do \
		gfile=`echo $${pfile} | sed s/\.pre/\.gen\.c/`; \
		echo "/* DO NOT EDIT, autogenerated from $${pfile} */" > "$${gfile}"; \
		echo "/* Modify $${pfile} then run make generate-code */" >> "$${gfile}"; \
		cat $${pfile} | $(CC) -E - | grep -v "^#" > "$${gfile}.tmp"; \
		sed -i -n -e '/^BEGIN:$$/,$$p' "$${gfile}.tmp"; \
		sed -i 's/^BEGIN:$$//' "$${gfile}.tmp"; \
		cat "$${gfile}.tmp" >> $${gfile}; \
		clang-format -i --verbose "$${gfile}"; \
		rm "$${gfile}.tmp"; \
	done

generate-docs:
	for mdfile in docs/*.md; do \
		echo "Processing $${mdfile}"; \
		manfile=`echo $${mdfile} | sed s/\.md//`; \
		pandoc --standalone --to man $${mdfile} -o $${manfile}; \
	done

dist:
	rm -fr distdir
	meson setup distdir
	meson compile -C distdir pkcs11
	meson test -C distdir
	meson dist -C distdir

=== meson_options.txt ===
option('preload_libasan',
       type: 'string',
       value: 'no',
       description: 'Path to libasan.so to preload')

option('enable_explicit_EC_test',
       type: 'boolean',
       value: false,
       description: 'Enable explicit EC tests')

option('default_pkcs11_module',
    type : 'string',
    value : '',
    description : 'Path to the default PKCS11 module')

## pkcs11-provider 0.3

=== debian/changelog ===
pkcs11-provider (0.3-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:11:08 +1100

pkcs11-provider (0.3-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:04:06 +0000

pkcs11-provider (0.3-1) unstable; urgency=medium

  * Mention header copyright holder in d/copyright
  * Update upstream source from tag 'upstream/0.3' (Closes: #1057937)
  * Drop patch to disable tests, no longer needed
  * Bump libssl dependency to 3.0.7

 -- Luca Boccassi <bluca@debian.org>  Mon, 22 Jan 2024 21:32:36 +0000

pkcs11-provider (0.2+g20231107-1) unstable; urgency=medium

  * Merge git snapshot from upstream to drop non-DFSG-free headers
  * Disable broken tests

 -- Luca Boccassi <bluca@debian.org>  Tue, 07 Nov 2023 22:49:33 +0000

pkcs11-provider (0.2-1) unstable; urgency=medium

  * Initial release. (Closes: #1053818)

 -- Luca Boccassi <bluca@debian.org>  Wed, 11 Oct 2023 21:59:35 +0000

=== debian/control ===
Source: pkcs11-provider
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Luca Boccassi <bluca@debian.org>
Build-Depends: autoconf-archive,
               debhelper-compat (= 13),
               dh-package-notes,
               expect <!nocheck>,
               gnutls-bin <!nocheck>,
               libnss3-dev <!nocheck>,
               libp11-kit-dev <!nocheck>,
               libssl-dev (>= 3.0.7~),
               libstoken-dev <!nocheck>,
               opensc <!nocheck>,
               openssl <!nocheck>,
               p11-kit <!nocheck>,
               p11-kit-modules <!nocheck>,
               pkg-config,
               softhsm2 <!nocheck>,
Homepage: https://github.com/latchset/pkcs11-provider
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/pkcs11-provider
Vcs-Git: https://salsa.debian.org/debian/pkcs11-provider.git

Package: pkcs11-provider
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: OpenSSL 3 provider for PKCS11
 With this provider for OpenSSL you can use the OpenSSL library
 (version 3) and command line tools with any PKCS11 implementation as
 backend for the crypto operations.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk
include /usr/share/debhelper/dh_package_notes/package-notes.mk

%:
	dh $@

execute_before_dh_install:
	find debian/pkcs11-provider \( -name '*.la' -o -name '*.a' \) -delete

## pkcs11-provider 0.5

=== debian/changelog ===
pkcs11-provider (0.5-2) unstable; urgency=medium

  * Backport patch to fix build on 32bit architectures (Closes: #1086250)

 -- Luca Boccassi <bluca@debian.org>  Tue, 29 Oct 2024 18:41:42 +0000

pkcs11-provider (0.5-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/0.5'

 -- Luca Boccassi <bluca@debian.org>  Wed, 05 Jun 2024 17:51:51 +0100

pkcs11-provider (0.4-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/0.4'
  * Switch from autotools to meson
  * Re-enable build time tests

 -- Luca Boccassi <bluca@debian.org>  Wed, 22 May 2024 14:13:18 +0100

pkcs11-provider (0.3-2) unstable; urgency=medium

  * Disable tests (Closes: #1068657)
  * Switch to pkgconf
  * Bump Standards-Version to 4.7.0, no changes

 -- Luca Boccassi <bluca@debian.org>  Sat, 13 Apr 2024 18:31:26 +0100

## pkcs11-provider 0.6

=== debian/changelog ===
pkcs11-provider (0.6-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/0.6'
  * Drop patches, merged upstream

 -- Luca Boccassi <bluca@debian.org>  Fri, 22 Nov 2024 21:58:53 +0000

## pkcs11-provider 1.0

=== debian/changelog ===
pkcs11-provider (1.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.0'

 -- Luca Boccassi <bluca@debian.org>  Tue, 11 Feb 2025 19:09:10 +0000

=== debian/control ===
Source: pkcs11-provider
Section: libs
Priority: optional
Maintainer: Luca Boccassi <bluca@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-package-notes,
               libssl-dev (>= 3.0.7~),
               meson (>= 0.57~),
               pkgconf,
               expect <!nocheck>,
               gnutls-bin <!nocheck>,
               libnss3-dev <!nocheck>,
               libp11-kit-dev <!nocheck>,
               libstoken-dev <!nocheck>,
               opensc <!nocheck>,
               openssl <!nocheck>,
               p11-kit <!nocheck>,
               p11-kit-modules <!nocheck>,
               softhsm2 <!nocheck>,
Homepage: https://github.com/latchset/pkcs11-provider
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/pkcs11-provider
Vcs-Git: https://salsa.debian.org/debian/pkcs11-provider.git

Package: pkcs11-provider
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: OpenSSL 3 provider for PKCS11
 With this provider for OpenSSL you can use the OpenSSL library
 (version 3) and command line tools with any PKCS11 implementation as
 backend for the crypto operations.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk
include /usr/share/debhelper/dh_package_notes/package-notes.mk

%:
	dh $@ --buildsystem=meson

## pkcs11-provider 1.1.0

=== Makefile ===
CLANG_FORMAT ?= clang-format
CLANG_FORMAT_DIFF ?= clang-format-diff

.PHONY: all check check-style check-style-show check-style-fix clean generate-code generate-docs

all:
	if [ ! -d "builddir" ]; then \
		meson setup builddir; \
	fi; \
	meson compile -C builddir pkcs11

check:
	meson test -C builddir

clean:
	rm -rf builddir

check-style:
	@lines=`git diff -U0 --no-color --relative origin/main -- ':!src/pkcs11.h' | $(CLANG_FORMAT_DIFF) -p1 |wc -l`; \
	if [ "$$lines" != "0" ]; then \
		echo "Coding Style issues detected"; \
		exit 1; \
	else \
		echo "Coding Styles checks out"; \
	fi

check-style-show:
	git diff -U0 --no-color --relative origin/main -- ':!src/pkcs11.h' | $(CLANG_FORMAT_DIFF) -p1

check-style-fix:
	git diff -U0 --no-color --relative origin/main -- ':!src/pkcs11.h' | $(CLANG_FORMAT_DIFF) -i -p1

shellcheck:
	shellcheck -P tests -e SC2016 tests/*.sh tests/test-wrapper tests/t{basic,certs,cms,democa,digest,ecc,ecdh,ecxc,edwards,forking,hkdf,imported,oaepsha2,op_state,pem_encoder,pinlock,pubkey,rand,rsa,rsapss,rsapssam,tls,tlsfuzzer,uri}

generate-code:
	for pfile in src/*.pre; do \
		gfile=`echo $${pfile} | sed s/\.pre/\.gen\.c/`; \
		echo "/* DO NOT EDIT, autogenerated from $${pfile} */" > "$${gfile}"; \
		echo "/* Modify $${pfile} then run make generate-code */" >> "$${gfile}"; \
		cat $${pfile} | $(CC) $(CFLAGS) -E - | grep -v "^#" > "$${gfile}.tmp"; \
		sed -i -n -e '/^BEGIN:$$/,$$p' "$${gfile}.tmp"; \
		sed -i 's/^BEGIN:$$//' "$${gfile}.tmp"; \
		cat "$${gfile}.tmp" >> $${gfile}; \
		$(CLANG_FORMAT) -i --verbose "$${gfile}"; \
		rm "$${gfile}.tmp"; \
	done

generate-docs:
	for mdfile in docs/*.md; do \
		echo "Processing $${mdfile}"; \
		manfile=`echo $${mdfile} | sed s/\.md//`; \
		pandoc --standalone --to man $${mdfile} -o $${manfile}; \
	done

dist:
	rm -fr distdir
	meson setup distdir
	meson compile -C distdir pkcs11
	meson test -C distdir
	meson dist -C distdir

=== meson_options.txt ===
--- 
+++ 
@@ -12,3 +12,8 @@
     type : 'string',
     value : '',
     description : 'Path to the default PKCS11 module')
+
+option('build_info',
+    type : 'string',
+    value : '',
+    description : 'Optional string with build information, like a build id')

=== debian/changelog ===
pkcs11-provider (1.1.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.1.0'

 -- Luca Boccassi <bluca@debian.org>  Tue, 16 Sep 2025 19:34:03 +0100

pkcs11-provider (1.0-3) unstable; urgency=medium

  * Disable unit tests at build time (Closes: #1102965)

 -- Luca Boccassi <bluca@debian.org>  Mon, 14 Apr 2025 13:57:22 +0100

pkcs11-provider (1.0-2) unstable; urgency=medium

  * Add timeout multiplier for unit tests to fix FTBFS on slow
    architectures (Closes: #1095848)
  * Add workaround for blhc failing due to meson test not compiling with
    verbosity
  * d/control: bump Standards-Version to 4.7.2, no changes

 -- Luca Boccassi <bluca@debian.org>  Sat, 29 Mar 2025 01:25:16 +0000

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
                p11-kit-modules <!nocheck>,
                softhsm2 <!nocheck>,
 Homepage: https://github.com/latchset/pkcs11-provider
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/pkcs11-provider
 Vcs-Git: https://salsa.debian.org/debian/pkcs11-provider.git

=== debian/rules ===
--- 
+++ 
@@ -7,3 +7,10 @@
 
 %:
 	dh $@ --buildsystem=meson
+
+# Tests are unreliable and cause build failures on buildds
+override_dh_auto_test:
+
+execute_before_dh_auto_build:
+	# meson test does not compile with verbosity, but doesn't matter as it's test binaries
+	@echo 'blhc: ignore-line-regexp: .* Compiling C object tests.*'

## pkcs11-provider 1.2.0

=== debian/changelog ===
pkcs11-provider (1.2.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.2.0'
  * Drop priority from d/control, now defaults to optional
  * Drop Rules-Requires-Root, now defaults to no
  * Bump Standards-version to 4.7.3
  * Add patch to fix 32bit build

 -- Luca Boccassi <bluca@debian.org>  Thu, 19 Feb 2026 22:21:04 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: pkcs11-provider
 Section: libs
-Priority: optional
 Maintainer: Luca Boccassi <bluca@debian.org>
 Build-Depends: debhelper-compat (= 13),
                dh-package-notes,
@@ -18,8 +17,7 @@
                p11-kit-modules <!nocheck>,
                softhsm2 <!nocheck>,
 Homepage: https://github.com/latchset/pkcs11-provider
-Standards-Version: 4.7.2
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian/pkcs11-provider
 Vcs-Git: https://salsa.debian.org/debian/pkcs11-provider.git
